From 46d50079cefb23b905539123e9e0ccb9a5fed77b Mon Sep 17 00:00:00 2001
From: Thomas JUND <tjund@entrouvert.com>
Date: Tue, 7 Jan 2020 14:55:25 +0100
Subject: [PATCH] scss: links-list: use li border-bottom as item separator
 (#38821)

---
 static/arles/_custom.scss                   |  2 +-
 static/fontenay-sous-bois-2018/_custom.scss |  8 +-
 static/includes/_cells.scss                 | 99 ++++++++++-----------
 3 files changed, 55 insertions(+), 54 deletions(-)

diff --git a/static/arles/_custom.scss b/static/arles/_custom.scss
index 4d01568b..f9a3f658 100644
--- a/static/arles/_custom.scss
+++ b/static/arles/_custom.scss
@@ -275,7 +275,7 @@ form.combo-search-form {
 .combo-search-results {
 	width: 60%;
 	margin: 0 auto;
-	div.links-list ul > li > a {
+	div.links-list ul > li {
 		border: 0;
 	}
 	li div p {
diff --git a/static/fontenay-sous-bois-2018/_custom.scss b/static/fontenay-sous-bois-2018/_custom.scss
index f568a130..0b153711 100644
--- a/static/fontenay-sous-bois-2018/_custom.scss
+++ b/static/fontenay-sous-bois-2018/_custom.scss
@@ -304,10 +304,12 @@ div#content {
 			color: #888;
 			padding: 0.5rem 0.5rem;
 		}
-		li:hover a,
-		li.selected a {
-			color: $primary-color;
+		li:hover,
+		li.selected {
 			border-bottom: 1px solid $primary-color;
+			a {
+				color: $primary-color;
+			}
 		}
 	}
 }
diff --git a/static/includes/_cells.scss b/static/includes/_cells.scss
index 030cc1b1..8466317b 100644
--- a/static/includes/_cells.scss
+++ b/static/includes/_cells.scss
@@ -142,56 +142,59 @@ div.wcscurrentformscell ul {
 	position: relative;
 	z-index: 0;
 
-	& > li > a {
-		display: -ms-flexbox;
-		display: flex;
-		-ms-align-items: baseline;
-		align-items: baseline;
-
-		-ms-flex-wrap: wrap;
-		flex-wrap: wrap;
-		padding: 1rem;
-		color: $cell-entry-color;
+	& > li {
 		border-bottom: 1px solid $cell-entry-border-color;
-		position: relative;
 
-		&:hover {
-			color: $cell-entry-hover-color;
-			@if $cell-entry-hover-effect != none {
-				&:after {
-					width: 100%;
-					height: 100%;
+		> a {
+			display: -ms-flexbox;
+			display: flex;
+			-ms-align-items: baseline;
+			align-items: baseline;
+
+			-ms-flex-wrap: wrap;
+			flex-wrap: wrap;
+			padding: 1rem;
+			color: $cell-entry-color;
+			position: relative;
+
+			&:hover {
+				color: $cell-entry-hover-color;
+				@if $cell-entry-hover-effect != none {
+					&:after {
+						width: 100%;
+						height: 100%;
+					}
+				} @else {
+					background-color: $cell-entry-hover-background;
 				}
-			} @else {
-				background-color: $cell-entry-hover-background;
-			}
-		}
-		&:after {
-			@if $cell-entry-hover-effect != none {
-				background-color: $cell-entry-hover-background;
-				content: "";
-				position: absolute;
-				z-index: -1;
-				transition: all 0.3s ease;
-				box-sizing: border-box;
-				width: 0;
-			}
-			@if $cell-entry-hover-effect == left-to-right {
-				width: 0%; height: 100%; top: 0; left: 0;
-			}
-			@if $cell-entry-hover-effect == right-to-left {
-				width: 0%; height: 100%; top: 0; right: 0;
-			}
-			@if $cell-entry-hover-effect == top-to-bottom {
-				width: 100%; height: 0%; top: 0; left: 0;
 			}
-			@if $cell-entry-hover-effect == bottom-to-top {
-				width: 100%; height: 0%; bottom: 0; left: 0;
-			}
-			@if $cell-entry-hover-effect == middle-to-edges {
-				top: 50%;
-				left: 50%;
-				transition: translateY(-50%) translateX(-50%);
+			&:after {
+				@if $cell-entry-hover-effect != none {
+					background-color: $cell-entry-hover-background;
+					content: "";
+					position: absolute;
+					z-index: -1;
+					transition: all 0.3s ease;
+					box-sizing: border-box;
+					width: 0;
+				}
+				@if $cell-entry-hover-effect == left-to-right {
+					width: 0%; height: 100%; top: 0; left: 0;
+				}
+				@if $cell-entry-hover-effect == right-to-left {
+					width: 0%; height: 100%; top: 0; right: 0;
+				}
+				@if $cell-entry-hover-effect == top-to-bottom {
+					width: 100%; height: 0%; top: 0; left: 0;
+				}
+				@if $cell-entry-hover-effect == bottom-to-top {
+					width: 100%; height: 0%; bottom: 0; left: 0;
+				}
+				@if $cell-entry-hover-effect == middle-to-edges {
+					top: 50%;
+					left: 50%;
+					transition: translateY(-50%) translateX(-50%);
+				}
 			}
 		}
 	}
@@ -217,9 +220,6 @@ div.wcscurrentformscell ul {
 	}
 
 	li div.description {
-		position: relative;
-		top: -1px;
-		border-top: 1px solid $cell-background;
 		padding: 0 1rem;
 		font-size: 90%;
 		color: #666;
@@ -227,7 +227,6 @@ div.wcscurrentformscell ul {
 			margin-top: 0;
 			margin-bottom: 0.7em;
 		}
-		border-bottom: 1px solid $cell-entry-border-color;
 	}
 }
 
-- 
2.20.1